# -*- coding: utf-8 -*-
from setuphelpers import *
import json

def update_package():
    # Initializing variables
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    url_api = "https://api.github.com/repos/bardsoftware/ganttproject/releases/latest"
    # Getting latest version from official sources
    print("API used is: %s" % url_api)
    json_load = json.loads(wgets(url_api, proxies=proxies))
    for download in json_load["assets"]:
        if download["name"].endswith(".dmg"):
            url_dl = download["browser_download_url"]
            version = download["browser_download_url"].split('-')[-2]
            break
    # Use of the binary name because the git repository does not return the last release
    #version = url_dl.split("ganttproject-")[-1].split(".dmg")[0]
    latest_bin = "ganttproject-%s-intel.dmg" % version
    print("Latest %s version is: %s" % (control.name, version))
    print("Download url is: %s" % url_dl)
    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(url_dl, latest_bin, proxies=proxies)
        # Changing version of the package
        control.set_software_version(version)
        control.save_control_to_wapt()
        print("Changing package version to: %s in WAPT\\control" % control.version)
    # Deleting outdated binaries
    remove_outdated_binaries(version)